import logging
from typing import List  # 型ヒントのためにインポート

from selenium.webdriver import Chrome, ChromeOptions, Remote
from selenium.webdriver.common.by import By
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.support.ui import WebDriverWait
from selenium.common.exceptions import NoSuchElementException

# （略）


def navigate(driver: Remote):
    """
    目的のページに遷移する。
    """
    logging.info('Navigating...')
    driver.get('https://note.mu/')  # noteのトップページを開く。
    assert 'note' in driver.title  # タイトルに'note'が含まれていることを確認する。

    # 3回繰り返す。
    for _ in range(3):
        # 待つべき要素の番号（現在の要素数 + 10）を計算する。
        # 最初の2要素だけ親要素が異なるので、現在の要素数の計算からは除く。
        n = len(driver.find_elements_by_css_selector('.o-timeline > div > .o-timeline__item')) + 10
        # ページの一番下までスクロールする。
        driver.execute_script('scroll(0, document.body.scrollHeight)')
        logging.info('Waiting for contents to be loaded...')
        # n番目のコンテンツに対応する要素が表示されるまで待つ。nth-of-type()の番号は1始まり。
        # タイムアウトは10秒で、10秒待っても表示されない場合は例外が発生する。
        WebDriverWait(driver, 10).until(EC.visibility_of_element_located(
            (By.CSS_SELECTOR, f'.o-timeline__item:nth-of-type({n})')
        ))

# （略）
